﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace XamDataChartOtherSeriesBinderDemo
{
    public class SeriesBinderBehavior : DependencyObject
    {
        public static readonly DependencyProperty SeriesBinderProperty =
            DependencyProperty.RegisterAttached(
                "SeriesBinder",
                typeof(SeriesBinderInfo),
                typeof(SeriesBinderBehavior),
                new PropertyMetadata(null,
                    (o, e) =>
                    {
                        OnSeriesBiderChaged(o as XamDataChart,
                            e.OldValue as SeriesBinderInfo,
                            e.NewValue as SeriesBinderInfo);
                    }));

        public static SeriesBinderInfo GetSeriesBinder(DependencyObject target)
        {
            return target.GetValue(SeriesBinderProperty) as SeriesBinderInfo;
        }

        public static void SetSeriesBinder(DependencyObject target, object value)
        {
            target.SetValue(SeriesBinderProperty, value);
        }


        private static void OnSeriesBiderChaged(
            XamDataChart chart,
            SeriesBinderInfo oldVal,
            SeriesBinderInfo newVal)
        {
            if (chart == null)
            {
                return;
            }
            if (oldVal != null)
            {
                oldVal.DetachOwner(chart);
            }
            if (newVal != null)
            {
                newVal.AttachOwner(chart);
            }
        }
    }
}
